// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v4.25.6
// source: agent.proto

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	Agents_GetAgentByID_FullMethodName                    = "/martiancloud.phobos.api.agent.Agents/GetAgentByID"
	Agents_GetAgents_FullMethodName                       = "/martiancloud.phobos.api.agent.Agents/GetAgents"
	Agents_CreateAgent_FullMethodName                     = "/martiancloud.phobos.api.agent.Agents/CreateAgent"
	Agents_UpdateAgent_FullMethodName                     = "/martiancloud.phobos.api.agent.Agents/UpdateAgent"
	Agents_DeleteAgent_FullMethodName                     = "/martiancloud.phobos.api.agent.Agents/DeleteAgent"
	Agents_AssignServiceAccountToAgent_FullMethodName     = "/martiancloud.phobos.api.agent.Agents/AssignServiceAccountToAgent"
	Agents_UnassignServiceAccountFromAgent_FullMethodName = "/martiancloud.phobos.api.agent.Agents/UnassignServiceAccountFromAgent"
	Agents_CreateAgentSession_FullMethodName              = "/martiancloud.phobos.api.agent.Agents/CreateAgentSession"
	Agents_SendAgentSessionHeartbeat_FullMethodName       = "/martiancloud.phobos.api.agent.Agents/SendAgentSessionHeartbeat"
	Agents_CreateAgentSessionError_FullMethodName         = "/martiancloud.phobos.api.agent.Agents/CreateAgentSessionError"
)

// AgentsClient is the client API for Agents service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// Agents is the service for managing agents which are
// responsible for claiming and executing jobs.
type AgentsClient interface {
	// GetAgentByID returns an agent by its ID.
	GetAgentByID(ctx context.Context, in *GetAgentByIDRequest, opts ...grpc.CallOption) (*Agent, error)
	// GetAgents returns a list of agents.
	GetAgents(ctx context.Context, in *GetAgentsRequest, opts ...grpc.CallOption) (*GetAgentsResponse, error)
	// CreateAgent creates a new agent.
	CreateAgent(ctx context.Context, in *CreateAgentRequest, opts ...grpc.CallOption) (*Agent, error)
	// UpdateAgent updates an existing agent.
	UpdateAgent(ctx context.Context, in *UpdateAgentRequest, opts ...grpc.CallOption) (*Agent, error)
	// DeleteAgent deletes an existing agent.
	DeleteAgent(ctx context.Context, in *DeleteAgentRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// AssignServiceAccountToAgent assigns a service account to an agent.
	AssignServiceAccountToAgent(ctx context.Context, in *AssignServiceAccountToAgentRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// UnassignServiceAccountFromAgent unassigns a service account from an agent.
	UnassignServiceAccountFromAgent(ctx context.Context, in *UnassignServiceAccountFromAgentRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// CreateAgentSession creates a new session
	CreateAgentSession(ctx context.Context, in *CreateAgentSessionRequest, opts ...grpc.CallOption) (*AgentSession, error)
	// SendAgentSessionHeartbeat
	SendAgentSessionHeartbeat(ctx context.Context, in *AgentSessionHeartbeatRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// CreateAgentSessionError
	CreateAgentSessionError(ctx context.Context, in *CreateAgentSessionErrorRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type agentsClient struct {
	cc grpc.ClientConnInterface
}

func NewAgentsClient(cc grpc.ClientConnInterface) AgentsClient {
	return &agentsClient{cc}
}

func (c *agentsClient) GetAgentByID(ctx context.Context, in *GetAgentByIDRequest, opts ...grpc.CallOption) (*Agent, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Agent)
	err := c.cc.Invoke(ctx, Agents_GetAgentByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentsClient) GetAgents(ctx context.Context, in *GetAgentsRequest, opts ...grpc.CallOption) (*GetAgentsResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetAgentsResponse)
	err := c.cc.Invoke(ctx, Agents_GetAgents_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentsClient) CreateAgent(ctx context.Context, in *CreateAgentRequest, opts ...grpc.CallOption) (*Agent, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Agent)
	err := c.cc.Invoke(ctx, Agents_CreateAgent_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentsClient) UpdateAgent(ctx context.Context, in *UpdateAgentRequest, opts ...grpc.CallOption) (*Agent, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Agent)
	err := c.cc.Invoke(ctx, Agents_UpdateAgent_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentsClient) DeleteAgent(ctx context.Context, in *DeleteAgentRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Agents_DeleteAgent_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentsClient) AssignServiceAccountToAgent(ctx context.Context, in *AssignServiceAccountToAgentRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Agents_AssignServiceAccountToAgent_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentsClient) UnassignServiceAccountFromAgent(ctx context.Context, in *UnassignServiceAccountFromAgentRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Agents_UnassignServiceAccountFromAgent_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentsClient) CreateAgentSession(ctx context.Context, in *CreateAgentSessionRequest, opts ...grpc.CallOption) (*AgentSession, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(AgentSession)
	err := c.cc.Invoke(ctx, Agents_CreateAgentSession_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentsClient) SendAgentSessionHeartbeat(ctx context.Context, in *AgentSessionHeartbeatRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Agents_SendAgentSessionHeartbeat_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *agentsClient) CreateAgentSessionError(ctx context.Context, in *CreateAgentSessionErrorRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Agents_CreateAgentSessionError_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// AgentsServer is the server API for Agents service.
// All implementations must embed UnimplementedAgentsServer
// for forward compatibility.
//
// Agents is the service for managing agents which are
// responsible for claiming and executing jobs.
type AgentsServer interface {
	// GetAgentByID returns an agent by its ID.
	GetAgentByID(context.Context, *GetAgentByIDRequest) (*Agent, error)
	// GetAgents returns a list of agents.
	GetAgents(context.Context, *GetAgentsRequest) (*GetAgentsResponse, error)
	// CreateAgent creates a new agent.
	CreateAgent(context.Context, *CreateAgentRequest) (*Agent, error)
	// UpdateAgent updates an existing agent.
	UpdateAgent(context.Context, *UpdateAgentRequest) (*Agent, error)
	// DeleteAgent deletes an existing agent.
	DeleteAgent(context.Context, *DeleteAgentRequest) (*emptypb.Empty, error)
	// AssignServiceAccountToAgent assigns a service account to an agent.
	AssignServiceAccountToAgent(context.Context, *AssignServiceAccountToAgentRequest) (*emptypb.Empty, error)
	// UnassignServiceAccountFromAgent unassigns a service account from an agent.
	UnassignServiceAccountFromAgent(context.Context, *UnassignServiceAccountFromAgentRequest) (*emptypb.Empty, error)
	// CreateAgentSession creates a new session
	CreateAgentSession(context.Context, *CreateAgentSessionRequest) (*AgentSession, error)
	// SendAgentSessionHeartbeat
	SendAgentSessionHeartbeat(context.Context, *AgentSessionHeartbeatRequest) (*emptypb.Empty, error)
	// CreateAgentSessionError
	CreateAgentSessionError(context.Context, *CreateAgentSessionErrorRequest) (*emptypb.Empty, error)
	mustEmbedUnimplementedAgentsServer()
}

// UnimplementedAgentsServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedAgentsServer struct{}

func (UnimplementedAgentsServer) GetAgentByID(context.Context, *GetAgentByIDRequest) (*Agent, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetAgentByID not implemented")
}
func (UnimplementedAgentsServer) GetAgents(context.Context, *GetAgentsRequest) (*GetAgentsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetAgents not implemented")
}
func (UnimplementedAgentsServer) CreateAgent(context.Context, *CreateAgentRequest) (*Agent, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateAgent not implemented")
}
func (UnimplementedAgentsServer) UpdateAgent(context.Context, *UpdateAgentRequest) (*Agent, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateAgent not implemented")
}
func (UnimplementedAgentsServer) DeleteAgent(context.Context, *DeleteAgentRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteAgent not implemented")
}
func (UnimplementedAgentsServer) AssignServiceAccountToAgent(context.Context, *AssignServiceAccountToAgentRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AssignServiceAccountToAgent not implemented")
}
func (UnimplementedAgentsServer) UnassignServiceAccountFromAgent(context.Context, *UnassignServiceAccountFromAgentRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UnassignServiceAccountFromAgent not implemented")
}
func (UnimplementedAgentsServer) CreateAgentSession(context.Context, *CreateAgentSessionRequest) (*AgentSession, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateAgentSession not implemented")
}
func (UnimplementedAgentsServer) SendAgentSessionHeartbeat(context.Context, *AgentSessionHeartbeatRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendAgentSessionHeartbeat not implemented")
}
func (UnimplementedAgentsServer) CreateAgentSessionError(context.Context, *CreateAgentSessionErrorRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateAgentSessionError not implemented")
}
func (UnimplementedAgentsServer) mustEmbedUnimplementedAgentsServer() {}
func (UnimplementedAgentsServer) testEmbeddedByValue()                {}

// UnsafeAgentsServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to AgentsServer will
// result in compilation errors.
type UnsafeAgentsServer interface {
	mustEmbedUnimplementedAgentsServer()
}

func RegisterAgentsServer(s grpc.ServiceRegistrar, srv AgentsServer) {
	// If the following call pancis, it indicates UnimplementedAgentsServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&Agents_ServiceDesc, srv)
}

func _Agents_GetAgentByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetAgentByIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).GetAgentByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_GetAgentByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).GetAgentByID(ctx, req.(*GetAgentByIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agents_GetAgents_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetAgentsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).GetAgents(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_GetAgents_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).GetAgents(ctx, req.(*GetAgentsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agents_CreateAgent_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateAgentRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).CreateAgent(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_CreateAgent_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).CreateAgent(ctx, req.(*CreateAgentRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agents_UpdateAgent_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateAgentRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).UpdateAgent(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_UpdateAgent_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).UpdateAgent(ctx, req.(*UpdateAgentRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agents_DeleteAgent_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteAgentRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).DeleteAgent(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_DeleteAgent_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).DeleteAgent(ctx, req.(*DeleteAgentRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agents_AssignServiceAccountToAgent_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AssignServiceAccountToAgentRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).AssignServiceAccountToAgent(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_AssignServiceAccountToAgent_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).AssignServiceAccountToAgent(ctx, req.(*AssignServiceAccountToAgentRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agents_UnassignServiceAccountFromAgent_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UnassignServiceAccountFromAgentRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).UnassignServiceAccountFromAgent(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_UnassignServiceAccountFromAgent_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).UnassignServiceAccountFromAgent(ctx, req.(*UnassignServiceAccountFromAgentRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agents_CreateAgentSession_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateAgentSessionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).CreateAgentSession(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_CreateAgentSession_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).CreateAgentSession(ctx, req.(*CreateAgentSessionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agents_SendAgentSessionHeartbeat_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AgentSessionHeartbeatRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).SendAgentSessionHeartbeat(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_SendAgentSessionHeartbeat_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).SendAgentSessionHeartbeat(ctx, req.(*AgentSessionHeartbeatRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Agents_CreateAgentSessionError_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateAgentSessionErrorRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AgentsServer).CreateAgentSessionError(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Agents_CreateAgentSessionError_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AgentsServer).CreateAgentSessionError(ctx, req.(*CreateAgentSessionErrorRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Agents_ServiceDesc is the grpc.ServiceDesc for Agents service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Agents_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "martiancloud.phobos.api.agent.Agents",
	HandlerType: (*AgentsServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetAgentByID",
			Handler:    _Agents_GetAgentByID_Handler,
		},
		{
			MethodName: "GetAgents",
			Handler:    _Agents_GetAgents_Handler,
		},
		{
			MethodName: "CreateAgent",
			Handler:    _Agents_CreateAgent_Handler,
		},
		{
			MethodName: "UpdateAgent",
			Handler:    _Agents_UpdateAgent_Handler,
		},
		{
			MethodName: "DeleteAgent",
			Handler:    _Agents_DeleteAgent_Handler,
		},
		{
			MethodName: "AssignServiceAccountToAgent",
			Handler:    _Agents_AssignServiceAccountToAgent_Handler,
		},
		{
			MethodName: "UnassignServiceAccountFromAgent",
			Handler:    _Agents_UnassignServiceAccountFromAgent_Handler,
		},
		{
			MethodName: "CreateAgentSession",
			Handler:    _Agents_CreateAgentSession_Handler,
		},
		{
			MethodName: "SendAgentSessionHeartbeat",
			Handler:    _Agents_SendAgentSessionHeartbeat_Handler,
		},
		{
			MethodName: "CreateAgentSessionError",
			Handler:    _Agents_CreateAgentSessionError_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "agent.proto",
}
